
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Inventory_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.create(
            {
                id: data.id || undefined,
        
        on_hand_qty: data.on_hand_qty
        ||
        null
            ,
            
        reserved_qty: data.reserved_qty
        ||
        null
            ,
            
        available_qty: data.available_qty
        ||
        null
            ,
            
        last_counted_at: data.last_counted_at
        ||
        null
            ,
            
        note: data.note
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await inventory_items.setTenant( data.tenant || null, {
            transaction,
        });
        
        await inventory_items.setProduct( data.product || null, {
            transaction,
        });
        
        await inventory_items.setWarehouse( data.warehouse || null, {
            transaction,
        });
        
        await inventory_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return inventory_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const inventory_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                on_hand_qty: item.on_hand_qty
            ||
            null
            ,
            
                reserved_qty: item.reserved_qty
            ||
            null
            ,
            
                available_qty: item.available_qty
            ||
            null
            ,
            
                last_counted_at: item.last_counted_at
            ||
            null
            ,
            
                note: item.note
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const inventory_items = await db.inventory_items.bulkCreate(inventory_itemsData, { transaction });

        // For each item created, replace relation files
        

        return inventory_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const inventory_items = await db.inventory_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.on_hand_qty !== undefined) updatePayload.on_hand_qty = data.on_hand_qty;
        
        
        if (data.reserved_qty !== undefined) updatePayload.reserved_qty = data.reserved_qty;
        
        
        if (data.available_qty !== undefined) updatePayload.available_qty = data.available_qty;
        
        
        if (data.last_counted_at !== undefined) updatePayload.last_counted_at = data.last_counted_at;
        
        
        if (data.note !== undefined) updatePayload.note = data.note;
        
        
        updatePayload.updatedById = currentUser.id;

        await inventory_items.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await inventory_items.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.product !== undefined) {
            await inventory_items.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.warehouse !== undefined) {
            await inventory_items.setWarehouse(
              
              data.warehouse,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await inventory_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return inventory_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of inventory_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of inventory_items) {
                await record.destroy({transaction});
            }
        });


        return inventory_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findByPk(id, options);

        await inventory_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await inventory_items.destroy({
            transaction
        });

        return inventory_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findOne(
            { where },
            { transaction },
        );

        if (!inventory_items) {
            return inventory_items;
        }

        const output = inventory_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await inventory_items.getTenant({
            transaction
        });
        
        
        output.product = await inventory_items.getProduct({
            transaction
        });
        
        
        output.warehouse = await inventory_items.getWarehouse({
            transaction
        });
        
        
        output.organizations = await inventory_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              tenant_name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              product_name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.warehouses,
        as: 'warehouse',
        
        where: filter.warehouse ? {
          [Op.or]: [
            { id: { [Op.in]: filter.warehouse.split('|').map(term => Utils.uuid(term)) } },
            {
              warehouse_name: {
                [Op.or]: filter.warehouse.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.note) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inventory_items',
                        'note',
                        filter.note,
                    ),
                };
            }
            

            
            

            
            if (filter.on_hand_qtyRange) {
                const [start, end] = filter.on_hand_qtyRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    on_hand_qty: {
                    ...where.on_hand_qty,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    on_hand_qty: {
                    ...where.on_hand_qty,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reserved_qtyRange) {
                const [start, end] = filter.reserved_qtyRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reserved_qty: {
                    ...where.reserved_qty,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reserved_qty: {
                    ...where.reserved_qty,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.available_qtyRange) {
                const [start, end] = filter.available_qtyRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    available_qty: {
                    ...where.available_qty,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    available_qty: {
                    ...where.available_qty,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_counted_atRange) {
                const [start, end] = filter.last_counted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_counted_at: {
                    ...where.last_counted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_counted_at: {
                    ...where.last_counted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.inventory_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'inventory_items',
                        'note',
                        query,
                    ),
                ],
            };
        }

        const records = await db.inventory_items.findAll({
            attributes: [ 'id', 'note' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['note', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.note,
        }));
    }

    
};

